#include "test.h"
#include "queue.h"

int test_add() {
  puts("---");
  puts("test_add");
  int failed = 0;
  struct Queue *q = malloc(sizeof(struct Queue));
  queue_init(q, 5);
  puts("initialized");
  unsigned char c;
  failed = failed || queue_add(q, 'a');
  return failed;
}

int test_size() {
  puts("---");
  puts("test_size");
  int failed = 0;
  struct Queue *q = malloc(sizeof(struct Queue));
  queue_init(q, 4);
  unsigned char c;
  failed = failed || queue_size(q) != 0;
  printf("size: %d\n", queue_size(q));
  queue_print(q);

  queue_add(q, 'a');

  printf("size: %d\n", queue_size(q));
  queue_print(q);
  failed = failed || queue_size(q) != 1;

  queue_add(q, 'b');

  printf("size: %d\n", queue_size(q));
  queue_print(q);
  failed = failed || queue_size(q) != 2;

  queue_add(q, 'c');

  printf("size: %d\n", queue_size(q));
  queue_print(q);
  failed = failed || queue_size(q) != 3;

  queue_add(q, 'd');

  printf("size: %d\n", queue_size(q));
  queue_print(q);
  failed = failed || queue_size(q) != 4;

  queue_remove(q, &c);
  queue_remove(q, &c);

  printf("size: %d\n", queue_size(q));
  queue_print(q);
  failed = failed || queue_size(q) != 2;

  queue_add(q, 'e');

  printf("size: %d\n", queue_size(q));
  queue_print(q);
  failed = failed || queue_size(q) != 3;

  return failed;
}

int test_full_when_full() {
  puts("---");
  puts("test_full_when_full");
  int failed = 0;
  struct Queue *q = malloc(sizeof(struct Queue));
  queue_init(q, 4);
  unsigned char c;
  queue_add(q, 'a');
  queue_add(q, 'b');
  queue_add(q, 'c');
  queue_add(q, 'd');
  failed = failed || !queue_full(q);
  return failed;
}

int test_add_when_full() {
  puts("---");
  puts("test_add_when_full");
  int failed = 0;
  struct Queue *q = malloc(sizeof(struct Queue));
  queue_init(q, 4);
  unsigned char c;
  queue_add(q, 'a');
  queue_add(q, 'b');
  queue_add(q, 'c');
  queue_add(q, 'd');
  queue_print(q);
  failed = failed || !queue_add(q, 'x');
  queue_remove(q, &c);
  queue_print(q);
  failed = failed || !(c == 'a');
  queue_remove(q, &c);
  queue_print(q);
  failed = failed || !(c == 'b');
  queue_remove(q, &c);
  queue_print(q);
  failed = failed || !(c == 'c');
  queue_remove(q, &c);
  queue_print(q);
  failed = failed || !(c == 'd');
  return failed;
}

int test_add_over_edge() {
  int failed = 0;
  struct Queue *q = malloc(sizeof(struct Queue));
  queue_init(q, 4);
  unsigned char c;
  queue_add(q, 'x');
  queue_add(q, 'x');
  queue_remove(q, &c);
  queue_remove(q, &c);
  queue_add(q, 'a');
  queue_add(q, 'b');
  queue_add(q, 'c');
  queue_add(q, 'd');
  queue_print(q);
  failed = failed || !queue_add(q, 'x');
  queue_remove(q, &c);
  failed = failed || !(c == 'a');
  queue_remove(q, &c);
  failed = failed || !(c == 'b');
  queue_remove(q, &c);
  failed = failed || !(c == 'c');
  queue_remove(q, &c);
  failed = failed || !(c == 'd');
  return failed;
}

int main() {
  test(test_add, "test_add");
  test(test_size, "test_size");
  test(test_full_when_full, "test_full_when_full");
  test(test_add_when_full, "test_add_when_full");
  test(test_add_over_edge, "test_add_over_edge");
  return test_summary();
}
